// THIS FILE IS GENERATED
// WARNING! All changes made in this file will be lost!

#include ".parser.h"



#include <QtCore/QDebug>
#include <KTextEditor/Range>

namespace Erlang
{

void Parser::tokenize(const QString& contents, int initialState)
{
    m_contents = contents;
    Lexer lexer(tokenStream, contents, initialState);
    int kind = Parser::Token_EOF;
    int lastDocCommentBegin;
    int lastDocCommentEnd;

    do
    {
        lastDocCommentBegin = 0;
        lastDocCommentEnd = 0;
        kind = lexer.nextTokenKind();
        while (kind == Parser::Token_WHITESPACE || kind == Parser::Token_COMMENT)
        {
            kind = lexer.nextTokenKind();
        }
        if ( !kind ) // when the lexer returns 0, the end of file is reached
        {
            kind = Parser::Token_EOF;
        }
        Parser::Token &t = tokenStream->next();
        t.begin = lexer.tokenBegin();
        t.end = lexer.tokenEnd();
        t.kind = kind;
        if ( m_debug ) qDebug() << kind << tokenText(t.begin,t.end) << t.begin << t.end;
    }
    while ( kind != Parser::Token_EOF );

    yylex(); // produce the look ahead token
}

QString Parser::tokenText(qint64 begin, qint64 end)
{
    return m_contents.mid(begin,end-begin+1);
}

void Parser::reportProblem( Parser::ProblemType type, const QString& message )
{
    if (type == Error)
        qDebug() << "** ERROR:" << message;
    else if (type == Warning)
        qDebug() << "** WARNING:" << message;
    else if (type == Info)
        qDebug() << "** Info:" << message;

    qint64 sLine;
    qint64 sCol;
    qint64 index = tokenStream->index()-1;
    tokenStream->startPosition(index, &sLine, &sCol);
    qint64 eLine;
    qint64 eCol;
    tokenStream->endPosition(index, &eLine, &eCol);
    KDevelop::Problem *p = new KDevelop::Problem();
    p->setSource(KDevelop::ProblemData::Parser);
    switch ( type )
    {
    case Error:
        p->setSeverity(KDevelop::ProblemData::Error);
        break;
    case Warning:
        p->setSeverity(KDevelop::ProblemData::Warning);
        break;
    case Info:
        p->setSeverity(KDevelop::ProblemData::Hint);
        break;
    }
    p->setDescription(message);
    p->setFinalLocation(KDevelop::DocumentRange(m_currentDocument, KTextEditor::Range(sLine, sCol, eLine, eCol+1)));
    m_problems << KDevelop::ProblemPointer(p);
}


// custom error recovery
void Parser::expectedToken(int /*expected*/, qint64 /*where*/, const QString& name)
{
    reportProblem( Parser::Error, QString("Expected token \"%1\"").arg(name));
}

void Parser::expectedSymbol(int /*expectedSymbol*/, const QString& name)
{
    qint64 line;
    qint64 col;
    qint64 index = tokenStream->index()-1;
    Token &token = tokenStream->token(index);
    kDebug() << "token starts at:" << token.begin;
    kDebug() << "index is:" << index;
    tokenStream->startPosition(index, &line, &col);
    QString tokenValue = tokenText(token.begin, token.end);
    qint64 eLine;
    qint64 eCol;
    tokenStream->endPosition(index, &eLine, &eCol);
    reportProblem( Parser::Error,
                   QString("Expected symbol \"%1\" (current token: \"%2\" [%3] at %4:%5 - %6:%7)")
                   .arg(name)
                   .arg(token.kind != 0 ? tokenValue : "EOF")
                   .arg(token.kind)
                   .arg(line)
                   .arg(col)
                   .arg(eLine)
                   .arg(eCol));
}

void Parser::setDebug( bool debug )
{
    m_debug = debug;
}

void Parser::setCurrentDocument(QString url)
{
    m_currentDocument = url;
}

Parser::ParserState *Parser::copyCurrentState()
{
    ParserState *state = new ParserState();
    state->varExpressionState = m_state.varExpressionState;
    state->varExpressionIsVariable = m_state.varExpressionIsVariable;
    return state;
}

void Parser::restoreState( Parser::ParserState* state)
{
    m_state.varExpressionState = state->varExpressionState;
    m_state.varExpressionIsVariable = state->varExpressionIsVariable;
}

} // end of namespace Erlang


namespace .
{

bool Parser::parseExpression(ExpressionAst **yynode)
{
    *yynode = create<ExpressionAst>();

    (*yynode)->startToken = tokenStream->index() - 1;

    if (yytoken == Token_STRING)
    {
        if (yytoken != Token_STRING)
        {
            expectedToken(yytoken, Token_STRING, "string");
            return false;
        }
        yylex();

    }
    else
    {
        return false;
    }

    (*yynode)->endToken = tokenStream->index() - 2;

    return true;
}

bool Parser::parseInnerStatementList(InnerStatementListAst **yynode)
{
    *yynode = create<InnerStatementListAst>();

    (*yynode)->startToken = tokenStream->index() - 1;

    if (yytoken == Token_HALT_COMPILER
        || yytoken == Token_STRING || yytoken == Token_EOF)
    {
        while (yytoken == Token_HALT_COMPILER
               || yytoken == Token_STRING)
        {
            TopStatementAst *__node_0 = 0;
            if (!parseTopStatement(&__node_0))
            {
                expectedSymbol(AstNode::TopStatementKind, "topStatement");
                return false;
            }
            (*yynode)->statementsSequence = snoc((*yynode)->statementsSequence, __node_0, memoryPool);

        }
    }
    else
    {
        return false;
    }

    (*yynode)->endToken = tokenStream->index() - 2;

    return true;
}

bool Parser::parseStart(StartAst **yynode)
{
    *yynode = create<StartAst>();

    (*yynode)->startToken = tokenStream->index() - 1;

    if (yytoken == Token_HALT_COMPILER
        || yytoken == Token_STRING || yytoken == Token_EOF)
    {
        InnerStatementListAst *__node_1 = 0;
        if (!parseInnerStatementList(&__node_1))
        {
            expectedSymbol(AstNode::InnerStatementListKind, "innerStatementList");
            return false;
        }
        (*yynode)->statements = __node_1;

        if (Token_EOF != yytoken)
        {
            return false;
        }
    }
    else
    {
        return false;
    }

    (*yynode)->endToken = tokenStream->index() - 2;

    return true;
}

bool Parser::parseStatement(StatementAst **yynode)
{
    *yynode = create<StatementAst>();

    (*yynode)->startToken = tokenStream->index() - 1;

    if (yytoken == Token_STRING)
    {
        ExpressionAst *__node_2 = 0;
        if (!parseExpression(&__node_2))
        {
            expectedSymbol(AstNode::ExpressionKind, "Expression");
            return false;
        }
        (*yynode)->expr = __node_2;

        if (yytoken != Token_DOT)
        {
            expectedToken(yytoken, Token_DOT, ".");
            return false;
        }
        yylex();

    }
    else
    {
        return false;
    }

    (*yynode)->endToken = tokenStream->index() - 2;

    return true;
}

bool Parser::parseTopStatement(TopStatementAst **yynode)
{
    *yynode = create<TopStatementAst>();

    (*yynode)->startToken = tokenStream->index() - 1;

    if (yytoken == Token_HALT_COMPILER
        || yytoken == Token_STRING)
    {
        if (yytoken == Token_STRING)
        {
            StatementAst *__node_3 = 0;
            if (!parseStatement(&__node_3))
            {
                expectedSymbol(AstNode::StatementKind, "statement");
                return false;
            }
            (*yynode)->statement = __node_3;

        }
        else if (yytoken == Token_HALT_COMPILER)
        {
            if (yytoken != Token_HALT_COMPILER)
            {
                expectedToken(yytoken, Token_HALT_COMPILER, "halt compiler");
                return false;
            }
            yylex();

            if (yytoken != Token_LPAREN)
            {
                expectedToken(yytoken, Token_LPAREN, "(");
                return false;
            }
            yylex();

            if (yytoken != Token_RPAREN)
            {
                expectedToken(yytoken, Token_RPAREN, ")");
                return false;
            }
            yylex();

            if (yytoken != Token_SEMICOLON)
            {
                expectedToken(yytoken, Token_SEMICOLON, ";");
                return false;
            }
            yylex();

        }
        else
        {
            return false;
        }
    }
    else
    {
        return false;
    }

    (*yynode)->endToken = tokenStream->index() - 2;

    return true;
}


} // end of namespace .

