// THIS FILE IS GENERATED
// WARNING! All changes made in this file will be lost!

#ifndef __H_INCLUDED
#define __H_INCLUDED

#include ".ast.h"
#include <kdev-pg-memory-pool.h>
#include <kdev-pg-allocator.h>

#include <parserexport.h>
namespace .
{

class KDEVERLANGPARSER_EXPORT Parser
{
public:
    typedef TokenStream::Token Token;
    TokenStream *tokenStream;
    int yytoken;

    inline Token LA(qint64 k = 1) const
    {
        return tokenStream->token(tokenStream->index() - 1 + k - 1);
    }
    inline int yylex()
    {
        return (yytoken = tokenStream->nextToken());
    }
    inline void rewind(qint64 index)
    {
        tokenStream->rewind(index);
        yylex();
    }

// token stream
    void setTokenStream(TokenStream *s)
    {
        tokenStream = s;
    }

// error handling
    void expectedSymbol(int kind, const QString& name);
    void expectedToken(int kind, qint64 token, const QString& name);

    bool mBlockErrors;
    inline bool blockErrors(bool block)
    {
        bool previous = mBlockErrors;
        mBlockErrors = block;
        return previous;
    }

// memory pool
    typedef KDevPG::MemoryPool memoryPoolType;

    KDevPG::MemoryPool *memoryPool;
    void setMemoryPool(KDevPG::MemoryPool *p)
    {
        memoryPool = p;
    }
    template <class T>
    inline T *create()
    {
        T *node = new (memoryPool->allocate(sizeof(T))) T();
        node->kind = T::KIND;
        return node;
    }

    enum TokenType
    {
        Token_AFTER = 1000,
        Token_AND = 1001,
        Token_ASSIGN = 1002,
        Token_BEGIN = 1003,
        Token_BIT_AND = 1004,
        Token_BIT_NOT = 1005,
        Token_BIT_OR = 1006,
        Token_BIT_XOR = 1007,
        Token_CASE = 1008,
        Token_CATCH = 1009,
        Token_COMMA = 1010,
        Token_COND = 1011,
        Token_DIV = 1012,
        Token_DNUMBER = 1013,
        Token_DOT = 1014,
        Token_DOUBLE_PIPE = 1015,
        Token_DOUBLE_QUOTE = 1016,
        Token_END = 1017,
        Token_EOF = 1018,
        Token_EXACT_EQUATIONAL = 1019,
        Token_EXACT_NOT_EQUATIONAL = 1020,
        Token_FUN = 1021,
        Token_HALT_COMPILER = 1022,
        Token_IF = 1023,
        Token_INT_DIV = 1024,
        Token_INT_REM = 1025,
        Token_INVALID = 1026,
        Token_IS_EQUAL = 1027,
        Token_IS_GREATER = 1028,
        Token_IS_GREATER_OR_EQUAL = 1029,
        Token_IS_NOT_EQUAL = 1030,
        Token_IS_SMALLER = 1031,
        Token_IS_SMALLER_OR_EQUAL = 1032,
        Token_LBRACE = 1033,
        Token_LBRACKET = 1034,
        Token_LEADS_TO = 1035,
        Token_LET = 1036,
        Token_LIST_ADDITION = 1037,
        Token_LIST_DIFFERENCE = 1038,
        Token_LNUMBER = 1039,
        Token_LPAREN = 1040,
        Token_MINUS = 1041,
        Token_MOD = 1042,
        Token_MUL = 1043,
        Token_NOT = 1044,
        Token_NUM_STRING = 1045,
        Token_OF = 1046,
        Token_OR = 1047,
        Token_PIPE = 1048,
        Token_PLUS = 1049,
        Token_POUND_SIGN = 1050,
        Token_QUERY = 1051,
        Token_QUESTION = 1052,
        Token_RBRACE = 1053,
        Token_RBRACKET = 1054,
        Token_RECEIVE = 1055,
        Token_RPAREN = 1056,
        Token_SEMICOLON = 1057,
        Token_SL = 1058,
        Token_SR = 1059,
        Token_STRING = 1060,
        Token_VARIABLE = 1061,
        Token_WHEN = 1062,
        Token_WHITESPACE = 1063,
        Token_XOR = 1064,
        TokenTypeSize
    }; // TokenType

// user defined declarations:
public:

    /**
     * Transform the raw input into tokens.
     * When this method returns, the parser's token stream has been filled
     * and any parse*() method can be called.
     */
    void tokenize(const QString& contents, int initialState = Lexer::HtmlState);

    enum ProblemType
    {
        Error,
        Warning,
        Info
    };
    void reportProblem( Parser::ProblemType type, const QString& message );
    QList<KDevelop::ProblemPointer> problems()
    {
        return m_problems;
    }
    QString tokenText(qint64 begin, qint64 end);
    void setDebug(bool debug);
    void setCurrentDocument(QString url);

    enum InitialLexerState
    {
        HtmlState = 0,
        DefaultState = 1
    };


private:

    enum VarExpressionState
    {
        Normal,
        OnlyVariable,
        OnlyNewObject
    };
    QString m_contents;
    bool m_debug;
    QString m_currentDocument;
    QList<KDevelop::ProblemPointer> m_problems;

    struct ParserState
    {
        VarExpressionState varExpressionState;
        bool varExpressionIsVariable;
    };
    ParserState m_state;


public:
    Parser()
    {
        memoryPool = 0;
        tokenStream = 0;
        yytoken = Token_EOF;
        mBlockErrors = false;

// user defined constructor code:

        m_state.varExpressionState = Normal;
        m_state.varExpressionIsVariable = false;

    }

    virtual ~Parser() {}

    bool parseExpression(ExpressionAst **yynode);
    bool parseInnerStatementList(InnerStatementListAst **yynode);
    bool parseStart(StartAst **yynode);
    bool parseStatement(StatementAst **yynode);
    bool parseTopStatement(TopStatementAst **yynode);
};

} // end of namespace .

#endif

